/*
 Copyright (C) 2022 Ivan Polyakov

 This file is part of vilor's website.

 Vilor's website is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Vilor's website is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef QUERY_H_ENTRY
#define QUERY_H_ENTRY

#ifdef __cplusplus
extern "C" {
#endif

#define PARAM_DEL       "&="
#define PARAM_BUFFSZ    100
#define MAX_PARAMVAL_SZ 10

struct param {
    const char *key;
    char *defaultval;
    char val[MAX_PARAMVAL_SZ];
};

struct param *find_param_by_key(struct param *params, const char *key);

void read_params(char *query, struct param *params);

void reset_params(struct param *params);

#ifdef __cplusplus
}
#endif

#endif /* QUERY_H_ENTRY */
