/*
 Copyright (C) 2022 Ivan Polyakov

 This file is part of vilor's website.

 Vilor's website is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Vilor's website is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef ROUTES_H_ENTRY
#define ROUTES_H_ENTRY

#include <stddef.h>
#include <fcgiapp.h>
#include "server.h"
#include "query.h"

#define ROUTESZ 255

#ifdef __cplusplus
extern "C" {
#endif

struct route {
    const char *uri;
    int (*resh)(struct route *route, FCGX_Request *req, const char **dest);
    struct param params[15];
};

/* responses */
int res_scrollbar(struct route *route, FCGX_Request *req, const char **dest);

static struct route routes[2] = {
    {
        "/webapps/scrollbar.html",
        &res_scrollbar,
        {
            /* key        defaultval val */
            { "sbw",       "10px",    "" },

            { "thumbclr",  "#9b3e46", "" },

            { "thumbbstl", "solid",   "" },
            { "thumbbrad", "8px",     "" },
            { "thumbbw",   "1px",     "" },
            { "thumbbclr", "#ffffff", "" },


            { "trackclr",  "#3b4252", "" },
            { "trackbrad", "8px",     "" },
            { "trackmt",   "0px",     "" },
            { "trackmb",   "0px",     "" },
            NULL
        }
    },
    NULL
};

struct route *find_route(FCGX_Request *req);

#ifdef __cplusplus
}
#endif

#endif /* ROUTES_H_ENTRY */
