;; Copyright (C) 2022 Ivan Polyakov
;;
;; This file is part of vilor's website.
;;
;; Vilor's website is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; Vilor's website is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

(load "../components/header.scm")
(load "../components/footer.scm")
(load "clean.scm")

(define* (default-tpl
           page-title
           page-name
           page-desc
           page-content

           #:optional
           (page-inline-style '())
           (page-scripts '())
           (page-meta '()))
  (clean-tpl
   page-title
   `(div (@ (class "wrapper"))
     ,header
     (hr)

     (main (@ (class "content container"))
           (h1 (@ (class "content__title")) ,page-name)
           (div (@ (class "content__description")) ,page-desc)
           ,page-content)

     (hr)
     ,footer)
   page-inline-style
   page-scripts
   page-meta))

'()
